Package com.io7m.jregions.core.parameterized.areas

# Class PAreaXYSplitD<S,​T extends PAreaDType<S>>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaXYSplitD<S,​T>

Type Parameters:
  `S` - A phantom type parameter indicating the coordinate space of the area
  `T` - The precise type of area

All Implemented Interfaces:
  `PAreaXYSplitDType<S,​T>`

    public final class PAreaXYSplitD<S,​T extends PAreaDType<S>>
    extends java.lang.Object
    implements PAreaXYSplitDType<S,​T>

An area that has been split into quadrants via an X and Y axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `PAreaXYSplitD.Builder<S,​T extends PAreaDType<S>>` | Builds instances of type `PAreaXYSplitD`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static <S,​ T extends PAreaDType<S>> PAreaXYSplitD.Builder<S,​T>` | `builder()` | Creates a builder for `PAreaXYSplitD`.
  `static <S,​ T extends PAreaDType<S>> PAreaXYSplitD<S,​T>` | `copyOf​(PAreaXYSplitDType<S,​T> instance)` | Creates an immutable copy of a `PAreaXYSplitDType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `PAreaXYSplitD` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `x0y0`, `x1y0`, `x0y1`, `x1y1`.
  `static <S,​ T extends PAreaDType<S>> PAreaXYSplitD<S,​T>` | `of​(T x0y0, T x1y0, T x0y1, T x1y1)` | Construct a new immutable `PAreaXYSplitD` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `PAreaXYSplitD` with attribute values.
  `PAreaXYSplitD<S,​T>` | `withX0y0​(T value)` | Copy the current immutable object by setting a value for the `x0y0` attribute.
  `PAreaXYSplitD<S,​T>` | `withX0y1​(T value)` | Copy the current immutable object by setting a value for the `x0y1` attribute.
  `PAreaXYSplitD<S,​T>` | `withX1y0​(T value)` | Copy the current immutable object by setting a value for the `x1y0` attribute.
  `PAreaXYSplitD<S,​T>` | `withX1y1​(T value)` | Copy the current immutable object by setting a value for the `x1y1` attribute.
  `T` | `x0y0()` |
  `T` | `x0y1()` |
  `T` | `x1y0()` |
  `T` | `x1y1()` |

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x0y0

    public T x0y0()
    Specified by:
      `x0y0` in interface `PAreaXYSplitDType<S,​T extends PAreaDType<S>>`
    Returns:
      The minimum X, minimum Y quadrant

  - ### x1y0

    public T x1y0()
    Specified by:
      `x1y0` in interface `PAreaXYSplitDType<S,​T extends PAreaDType<S>>`
    Returns:
      The maximum X, minimum Y quadrant

  - ### x0y1

    public T x0y1()
    Specified by:
      `x0y1` in interface `PAreaXYSplitDType<S,​T extends PAreaDType<S>>`
    Returns:
      The minimum X, maximum Y quadrant

  - ### x1y1

    public T x1y1()
    Specified by:
      `x1y1` in interface `PAreaXYSplitDType<S,​T extends PAreaDType<S>>`
    Returns:
      The maximum X, maximum Y quadrant

  - ### withX0y0

    public final PAreaXYSplitD<S,​T> withX0y0​(T value)
    Copy the current immutable object by setting a value for the `x0y0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y0
    Returns:
      A modified copy of the `this` object

  - ### withX1y0

    public final PAreaXYSplitD<S,​T> withX1y0​(T value)
    Copy the current immutable object by setting a value for the `x1y0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y0
    Returns:
      A modified copy of the `this` object

  - ### withX0y1

    public final PAreaXYSplitD<S,​T> withX0y1​(T value)
    Copy the current immutable object by setting a value for the `x0y1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y1
    Returns:
      A modified copy of the `this` object

  - ### withX1y1

    public final PAreaXYSplitD<S,​T> withX1y1​(T value)
    Copy the current immutable object by setting a value for the `x1y1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y1
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `PAreaXYSplitD` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x0y0`, `x1y0`, `x0y1`, `x1y1`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `PAreaXYSplitD` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static <S,​ T extends PAreaDType<S>> PAreaXYSplitD<S,​T> of​(T x0y0, T x1y0, T x0y1, T x1y1)
    Construct a new immutable `PAreaXYSplitD` instance.
    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Parameters:
      `x0y0` - The value for the `x0y0` attribute
      `x1y0` - The value for the `x1y0` attribute
      `x0y1` - The value for the `x0y1` attribute
      `x1y1` - The value for the `x1y1` attribute
    Returns:
      An immutable PAreaXYSplitD instance

  - ### copyOf

    public static <S,​ T extends PAreaDType<S>> PAreaXYSplitD<S,​T> copyOf​(PAreaXYSplitDType<S,​T> instance)
    Creates an immutable copy of a `PAreaXYSplitDType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PAreaXYSplitD instance

  - ### builder

    public static <S,​ T extends PAreaDType<S>> PAreaXYSplitD.Builder<S,​T> builder()
    Creates a builder for `PAreaXYSplitD`.

         PAreaXYSplitD.&lt;S, T&gt;builder()
            .setX0y0(T) // required x0y0
            .setX1y0(T) // required x1y0
            .setX0y1(T) // required x0y1
            .setX1y1(T) // required x1y1
            .build();

    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Returns:
      A new PAreaXYSplitD builder